Flowspec Indirection-id Redirect for SRv6
Gunter Van de Velde
Nokia
Antwerp
BE
gunter.van_de_velde@nokia.com
Keyur Patel
Arrcus
USA
keyur@arrcus.com
Zhenbin Li
Huawei Technologies
Huawei Bld., No. 156 Beiquing Rd
Beijing
100095
China
lizhenbin@huawei.com
Huaimo Chen
Futurewei
Boston, MA
USA
Huaimo.chen@futurewei.com
2024
Routing
IDR Working Group
This document defines extensions to "FlowSpec Redirect to indirection-id Extended Community" for SRv6. This extended community can trigger advanced redirection capabilities to flowspec clients for SRv6. When activated, this flowspec extended community is used by a flowspec client to retrieve the corresponding next-hop and encoding information within a localised indirection-id mapping table.
The functionality detailed in this document allows a network controller to decouple the BGP flowspec redirection instruction from the operation of the available paths.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in RFC 2119.

Introduction
"FlowSpec Redirect to indirection-id Extended Community" for IPv4 is defined in ietf-idr-flowspec-path-redirect.
This draft specifies extensions to this community for SRv6.

Redirect to indirection-id Community
This document defines a new sub-type value for SRv6 in "FlowSpec Redirect to indirection-id Extended Community". The format of this extended community with the new sub-type value is show below:

 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
| Type          |Sub-Type (TBD) | Flags(1 octet)|    ID-Type    |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|            Generalized indirection_id (16 octets)             |
~                                                               ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Where
Type: 1 octet, defined in ietf-idr-flowspec-path-redirect.
Sub-Type: 1 octet, its value (TBD) will be assigned by IANA.
Flags: Same as that defined in ietf-idr-flowspec-path-redirect.
ID-Type: 1 octet value. This draft defines following Context Types:
0 - Localised ID (The flowspec client uses the received indirection-id to lookup forwarding information within the localised indirection-id table. The allocation and programming of the localised indirection-id table is outside scope of the document)
1 - Node ID with SID/index in MPLS-based Segment Routing (This means the indirection-id is mapped to an MPLS label using the index as a global offset in the SID/label space)
2 - Node ID with SID/label in MPLS-based Segment Routing (This means the indirection-id is mapped to an MPLS label using the indirection-id as global label)
3 - Binding Segment ID with SID/index in MPLS-based Segment Routing (This means the indirection-id is mapped to an MPLS binding label using the indirection-id as index for global offset in the SID/label space).
4 - Binding Segment ID with SID/label in MPLS-based Segment Routing (This means indirection-id is mapped to an MPLS binding label using the indirection-id as global label).
5 - Tunnel ID (Tunnel ID is within a single administrative domain a globally unique tunnel identifier. The allocation and programming of the Tunnel ID within the localised indirection-id table is outside scope of the document)
6 - Node ID with SID/index in SRv6 (This means the indirection-id is mapped to an SRv6 SID using the indirection-id as global SRv6 SID or index)
7 - Binding Segment ID with SID/index in SRv6 (This means the indirection-id is mapped to an SRv6 binding SID using the indirection-id as index for global offset in the SID space).
8 - Binding Segment ID with SID/index in SRv6 (This means indirection-id is mapped to an SRv6 binding SID using the indirection-id as global SRv6 SID).
Generalized indirection_id: 128-bit identifier used as indirection_id

Security Considerations
A system using "Redirect to indirection-id" extended community can cause during the redirect mitigation of a DDoS attack overflow of traffic received by the mitigation infrastructure.

Acknowledgements
This document received valuable comments and input from IDR working group including Adam Simpson, Mustapha Aissaoui, Jan Mertens, Robert Raszuk, Jeff Haas, Susan Hares and Lucy Yong.

Contributor Addresses
Below is a list of other contributing authors in alphabetical order:

Arjun Sreekantiah
Cisco Systems
170 W. Tasman Drive
San Jose, CA  95134
USA

Email: asreekan@cisco.com

Nan Wu
Huawei Technologies
Huawei Bld., No. 156 Beiquing Rd
Beijing  100095
China

Email: eric.wu@huawei.com

Shunwan Zhuang
Huawei Technologies
Huawei Bld., No. 156 Beiquing Rd
Beijing  100095
China

Email: zhuangshunwan@huawei.com

Wim Henderickx
Nokia
Antwerp
BE

Email: wim.henderickx@nokia.com

IANA Considerations
This document requests a new sub-type value under "FlowSpec Redirect to indirection-id Extended Community Sub-Type" registery.

 Value   Code                                            Reference
 0x01    Flowspec Redirect to 128-bit Path-id for SRv6   [RFC-To-Be]

Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
Scott Bradner
Harvard University
1350 Mass. Ave.
Cambridge
MA 02138
- +1 617 495 3864
sob@harvard.edu
March 1997
General
keyword
BCP 14
RFC 2119

Informative References
[VALIDATE]

Revised Validation Procedure for BGP Flow Specifications
J. Uttaro
C. Filsfils
J. Alcaide
P. Mohapatra
January 2014
[EPE]

Segment Routing Centralized Egress Peer Engineering
C. Filsfils
S. Previdi
E. Aries
D. Ginsburg
D. Afanasiev
October 2015
[SR-TE]

Segment Routing Traffic Engineering Policy using BGP
A. Sreekantiah
C. Filsfils
S. Previdi
S. Sivabalan
P. Mattes
S. Lin
October 2015
[SR]

Segment Routing Architecture
C. Filsfils
S. Previdi
B. Decraene
S. Litkowski
R. Shakir
A. Bashandy
M. Horneffer
W. Henderickx
J. Tantsura
E. Crabbe
I. Milojevic
S. Ytti
December 2015
[SR-PCE]

PCEP Extensions for Segment Routing
S. Sivabalan
M. Medved
C. Filsfils
S. Litkowski
R. Raszuk
A. Bashandy
V. Lopez
J. Tantsura
W. Henderickx
J. Hardwick
I. Milojevic
S. Ytti
December 2015